﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics.CodeAnalysis;
using ProjectLinkor.Entities;

namespace ProjectLinkor.Drawnings;

public class DrawingShipEqutables : IEqualityComparer<DrawingShip?>
{
    public bool Equals(DrawingShip? x, DrawingShip? y)
    {
        if (ReferenceEquals(x, null)) return false;
        if (ReferenceEquals(y, null)) return false;
        if (x.GetType() != y.GetType()) return false;

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityShip != null && y.EntityShip != null && x.EntityShip.Speed != y.EntityShip.Speed)
        {
            return false;
        }

        if (x.EntityShip.Weight != y.EntityShip.Weight)
        {
            return false;
        }

        if (x.EntityShip.BodyColor != y.EntityShip.BodyColor)
        {
            return false;
        }
        if (x is DrawingLinkor && y is DrawingLinkor)
        {
            if (((EntityLinkor)x.EntityShip).AdditionalColor !=
                ((EntityLinkor)y.EntityShip).AdditionalColor)
            {
                return false;
            }
            if (((EntityLinkor)x.EntityShip).Rocket !=
                ((EntityLinkor)y.EntityShip).Rocket)
            {
                return false;
            }
            if (((EntityLinkor)x.EntityShip).Gun !=
                ((EntityLinkor)y.EntityShip).Gun)
            {
                return false;
            }
        }

        return true;
    }

    public int GetHashCode([DisallowNull] DrawingShip? obj)
    {
        return obj.GetHashCode();
    }
}
